' MoveHere.VBS V1.00 (C) yoshioka.teruo@nifty.com 2005-08-30
' MoveHere.VBS moves copied files or folders here.
' Usage: Start MoveHere.VBS [files|folders...]

Option Explicit
Const FOF_RENAMEONCOLLISION=&H8
Const FOF_ALLOWUNDO=&H40
Const ssfBITBUCKET=10'shell:RecycleBinFolder::{645FF040-5081-101B-9F08-00AA002F954E}
Dim fso
Dim Shell
Dim ie
Dim Folder
Dim FolderItem
Dim Verb
Dim arg
Dim args():ReDim args(WScript.Arguments.Count-1)
Dim k

Set fso=CreateObject("Scripting.FileSystemObject")
Set Shell=CreateObject("Shell.Application")
For k=0 To 9
  For Each ie In Shell.Windows() 
    If ie.Busy Then
    ElseIf ie.ReadyState<>4 Then
    ElseIf InStr(TypeName(ie.Document),"IShellFolderViewDual")<>1 Then
    ElseIf LCase(Mid(ie.FullName,InStrRev(ie.FullName,"\")))="\explorer.exe" Then
      Exit For 
    End If
  Next 
  If Not IsEmpty(ie) Then Exit For 
  If k=0 Then CreateObject("WScript.Shell").Run "explorer.exe",0,True 
  WScript.Sleep 100 
Next 
If IsEmpty(ie) Then WScript.Echo "Failed" : WScript.Quit 
If Not IsEmpty(ie) Then Set Shell=ie.Document.Application 

If WScript.Arguments.Count=0 Then
  If Mid(WScript.FullName,InStrRev(WScript.FullName,"\")-2,2)<>"32" Then
    WScript.Echo "Arguments Missing."
    WScript.Quit
  End If
  Set Folder=Shell.NameSpace(Left(WScript.ScriptFullName,InStrRev(WScript.ScriptFullName,"\")))
  Set FolderItem=Folder.Items.Item(WScript.ScriptName)
  For Each Verb In FolderItem.Verbs
    If Verb.Name="\t(&P)" Then Exit For
  Next
  If Not IsEmpty(Verb) Then
    Verb.DoIt
  Else
    WScript.Echo "Arguments Missing."
  End If
  WScript.Quit
Else
  Set Folder=Shell.Windows.Item.Document.Folder
  For k=0 To WScript.Arguments.Count-1 
    args(k)=WScript.Arguments(k)
  Next
  If MsgBox(Join(args,vbLf)&vbLf&_
    "To"&vbLf&Folder.Items.Item.Path,_
    vbOkCancel,"Move ?")=vbCancel Then WScript.Quit
  For Each arg In WScript.Arguments 
    Call MoveHere(Folder,arg)
  Next
End If

Sub MoveHere(Folder,Path)
Dim Name
Dim dFolderItem
Dim sFolderItem

Name=Mid(arg,InStrRev(Path,"\")+1)
Set sFolderItem=Shell.NameSpace(Left(arg,InStrRev(Path,"\"))).ParseName(Name)
Set dFolderItem=ParseName(Folder,Name)
If Not dFolderItem Is Nothing Then
  Select Case MsgBox("Move"&vbTab&sFolderItem.ModifyDate&vbTab&_
         FormatNumber(sFolderItem.Size,0)&vbTab&sFolderItem.Path&vbLf&_
         "To"&vbTab&dFolderItem.ModifyDate&vbTab&_
         FormatNumber(dFolderItem.Size,0)&vbTab&dFolderItem.Path&vbLf&_
         "Reply"&_
         vbTab&"Yes"&vbTab&"Sending the former file to Recycle Bin."&vbLf&_
         vbTab&"No"&vbTab&"Prefixing 'copy (n)' to the new file."&vbLf&_
         vbTab&"Cancel"&vbTab&"Not move.",_
         vbYesNoCancel,"Name Collision - "&Name)
  Case vbYes
    Shell.NameSpace(ssfBITBUCKET).MoveHere dFolderItem,FOF_ALLOWUNDO
    Do
      WScript.Sleep 100
      Set dFolderItem=ParseName(Folder,Name)
      If dFolderItem Is Nothing Then Exit Do
    Loop
    WScript.Sleep 200
    MoveFile sFolderItem.Path,Folder.Self.Path
  Case vbNo
    MoveFile sFolderItem.Path,Folder.Self.Path
  End Select
Else
  MoveFile sFolderItem.Path,Folder.Self.Path
End If
End Sub

Function ParseName(Folder,Name) 'For Windows98
Set ParseName=Nothing
On Error Resume Next
Set ParseName=Folder.ParseName(Name)
End Function

Sub MoveFile(Path,dst)
Dim File
Dim k
Dim FileName
Dim ExtensionName

If fso.FileExists(Path) Then
  Set File=fso.GetFile(Path)
Else
  Set File=fso.GetFolder(Path)
End If

For k=1 To 999
  If k=1 Then
    FileName=File.Name
    Call Move(File,fso.BuildPath(dst,FileName))
  Else
    FileName=fso.GetBaseName(File.Name) & k
'    FileName=fso.GetBaseName(File.Name) & " " & k
    ExtensionName=fso.GetExtensionName(File.Name)
    If ExtensionName<>"" Then FileName=FileName & "." & ExtensionName
    Call Move(File,fso.BuildPath(dst,FileName))
  End If
  Select Case Err.Number
  Case 0
    If k>1 Then MsgBox FileName&vbLf&"To"&vbLf&dst,vbOkCancel+vbInformation,"Moved and renamed."
    Exit For
  Case 58
    If MsgBox(Err.Number&" "&Err.Description&vbLf&dst&vbLf&FileName,_
      vbOkCancel+vbQuestion,"Rename on collision ?")=vbCancel Then WScript.Quit
  Case 70
    MsgBox Err.Number&" "&Err.Description&vbLf&dst&vbLf&FileName,vbOkOnly+vbCritical,"Failed. Maybe currently in use."
    WScript.Quit
  Case Else
    MsgBox Err.Number&" "&Err.Description&vbLf&dst&vbLf&FileName,vbOkOnly+vbCritical,"Failed. Unexpected error."
    WScript.Quit
  End Select
Next
End Sub

Sub Move(File,dst)
On Error Resume Next
Call File.Move(dst)
End Sub
